import numpy as np
m = [[0.0, 4.5], [0.0, 4.5], [11.6, 4.4], [12.2, 4.3], [1.4, 3.9], [1.4, 3.9], [2.5, 3.8], [0.1, 3.8], [0.5, 5.1], [0.7, 5.2], [0.7, 5.1], [0.0, 4.6], [0.0, 4.6]]
m = np.transpose(np.array(m))
xu_ = np.mean(m[1,:])
yu_ = np.mean(m[0,:])

xr_ = np.sqrt(np.var(m[0,:]))
yr_ = np.sqrt(np.var(m[1,:]))
#
# -- normalizing the matrix before computing covariance
#
mn = np.array([list( (m[0,:]-xu_)/xr_),list( (m[1,:]-yu_)/yr_)])
cx = np.cov(mn)
n = m.shape[0]
x = np.array([2.5,3.1])
u = np.array([xu_,yu_])
d = np.matrix(x - u)
d.shape = (n,1)
a  = (2*(np.pi)**(n/2))*np.linalg.det(cx)**0.5
b = np.exp(-0.5*np.transpose(d) * (cx**-1)*d)

from scipy.stats import multivariate_normal
xo= multivariate_normal.pdf(x,u,cx)
yo= (b/a)[0,0]
for row in np.transpose(m):
	print ",".join([str(value) for value in row])
#-- We are ready to perform anomaly detection ...
